function love.load()

    class = require "30log"
    require "common"
    require "player"
    require "bullet"

    player = Player()
    bullets = {}
    paused = false
    lFont = love.graphics.newFont(60)
    sFont = love.graphics.newFont(20)
    score = 0

end

function love.update(dt)

    if not paused then
        spawnBullets(dt)

        player:update(dt)

        local i = 1
        while i <= #bullets do
            local v = bullets[i]
            v:update(dt)

            if v.dead then
                table.remove(bullets, i)
                score = score + 1
            else
                i = i + 1
            end

            if v:hit(player) then
                paused = true
            end
        end
    elseif love.keyboard.isDown("space") then
        love.load()
    end
    
end

function love.draw()

    player:draw()

    for i,v in ipairs(bullets) do
        v:draw()
    end

    love.graphics.setColor(0.7,0.7,0.7)
    love.graphics.rectangle("fill",10,4*winHeight/5,winWidth-20,winHeight/5)
    love.graphics.rectangle("fill",10,0,winWidth-20,4*winHeight/5-150)

    love.graphics.setColor(0,0,0)
    love.graphics.setFont(lFont)
    love.graphics.print("Dodged " .. score .. " bullets.", 50, 50)
    love.graphics.setFont(sFont)
    love.graphics.print("Press 'W' to jump, 'S' to duck. 'SPACE' to restart when Game Over.", 50, 270)
    love.graphics.setColor(1,1,1)
    
end

function love.keypressed(key)

    local prev_state = player.state

    if key == "w" then
        player.state = "jump"
    elseif key == "s" then
        player.state = "crouch"
    end

    if player.state ~= prev_state then
        counter = 0
    end

end

function spawnBullets(dt)

    spawnTimer = spawnTimer + 2*dt

    if spawnTimer>1 then
        table.insert(bullets, Bullet())
        spawnTimer = 0
    end

end
